sns_conta/WebUI/webUI.SICO/Controllers/DocumentTypeController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using webUI.SICO.Models;
using businessLogic.Core;

namespace webUI.SICO.Controllers
{
    public class DocumentTypeController : Controller
    {
        // GET: DocumentType
        public ActionResult Index()
        {
            return View();
        }

        public ActionResult List()
        {
            var result = new List<CatalogStringViewModel>();
            var documentTypes = new DocumentType().GetAll("");
            foreach (var dt in documentTypes)
            {
                result.Add(new CatalogStringViewModel(dt.DocumentTypeId, dt.DocumentTypeName));
            }
            return View(result);
        }

        [HttpPost]
        public JsonResult Save(CatalogStringViewModel param)
        {

            ResponseModel result = new ResponseModel();
            try
            {
                var data = new DocumentType(param.Code, param.Value, true);
                var response = data.Add(data);
                result = new ResponseModel() { Id = "0", Message = string.Empty, Type = 'S' };
            }
            catch (Exception ex)
            {
                result = new ResponseModel() { Id = "1", Message = ex.Message, Type = 'E' };
            }
            return Json(result, JsonRequestBehavior.AllowGet);
        }


        [HttpPost]
        public JsonResult Delete(CatalogStringViewModel param)
        {

            ResponseModel result = new ResponseModel();
            try
            {
                var data = new DocumentType(param.Code, "", true);
                var response = data.Remove(data);
                result = new ResponseModel() { Id = "0", Message = string.Empty, Type = 'S' };
            }
            catch (Exception ex)
            {
                result = new ResponseModel() { Id = "1", Message = ex.Message, Type = 'E' };
            }
            return Json(result, JsonRequestBehavior.AllowGet);
        }


        [HttpPost]
        public JsonResult Edit(CatalogStringViewModel param)
        {
            ResponseModel result = new ResponseModel();
            try
            {
                var data = new DocumentType(param.Code, param.Value, true);
                var response = data.Update(data);
                result = new ResponseModel() { Id = "0", Message = string.Empty, Type = 'S' };
            }
            catch (Exception ex)
            {
                result = new ResponseModel() { Id = "1", Message = ex.Message, Type = 'E' };
            }
            return Json(result, JsonRequestBehavior.AllowGet);
        }

    }
}

sns_conta/WebUI/webUI.SICO/Views/DocumentType/List.cshtml
@model IEnumerable<webUI.SICO.Models.CatalogStringViewModel>

@{
    ViewBag.Title = "Tipos de Documento";
}



<div class="row">
    <div class="col-lg-12">
        <section class="card">
            <header class="card-header">
                <h4>
                    @ViewBag.Title
                    <span class="tools pull-right">
                        <a href="javascript:;" class="fa fa-chevron-down"></a>
                        <a href="javascript:;" class="fa fa-times"></a>
                    </span>
                </h4>
            </header>
            <div class="card-body">
                <a href="../Home/Index/" class="btn btn-shadow btn-default">
                    <span class="fa fa-arrow-left"></span> Atr&aacute;s...
                </a>
                <button class="btn btn-shadow btn-success" type="button" data-toggle="modal" data-target="#CreateModal">
                    <span class="fa fa-plus"></span> Nuevo
                </button>

            </div>
        </section>
    </div>
</div>

<div class="row">
    <div class="col-lg-12">
        <section class="card">
            <div class="card-body">
                <section id="flip-scroll">
                    <table class="table table-bordered table-striped table-condensed cf">
                        <thead class="cf">
                            <tr>
                                <th width="25%">
                                    C&oacute;digo
                                </th>
                                <th width="65%">
                                    Valor
                                </th>
                                <th width="10%"> Opciones</th>
                            </tr>
                        </thead>
                        <tbody>
                            @foreach (var item in Model)
                            {
                                <tr>
                                    <td>
                                        @Html.DisplayFor(modelItem => item.Code)
                                    </td>
                                    <td>
                                        @Html.DisplayFor(modelItem => item.Value)
                                    </td>
                                    <td>
                                        <span class="input-group-btn">
                                            <button class="btn btn-sm btn-default" type="button" data-toggle="modal" data-target="#EditModal" onclick="fnLoadEdit('@item.Code','@item.Value')">
                                                <span class="fa fa-pencil"></span>
                                            </button>
                                            <button class="btn btn-sm btn-danger" type="button" onclick="fnDelete('@item.Code')">
                                                <span class="fa fa-trash-o"></span>
                                            </button>
                                        </span>
                                    </td>
                                </tr>
                            }
                        </tbody>
                    </table>
                </section>
            </div>
        </section>
    </div>
</div>




    <!--==========================================================CREAR=============================================================-->
<div aria-hidden="true" aria-labelledby="myModalLabel" role="dialog" tabindex="-1" id="CreateModal" class="modal fade">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title">Crear @ViewBag.Title</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">

                <div class="form-group">

                    <div class="form-group">
                        <label for="txtCode">C&oacute;digo:</label>
                        <input type="text" class="form-control" id="txtCode" placeholder="C&oacute;digo">
                    </div>

                    <div class="form-group">
                        <label for="txtValue">Valor:</label>
                        <input type="text" class="form-control" id="txtValue" placeholder="Valor">
                    </div>
                    <hr />
                    <div class="input-group">
                        <span class="input-group-btn">
                            <button id="btnSave" class="btn btn-success" type="button" onclick="fnSave()">
                                <span class="glyphicon glyphicon-save"></span>
                                Guardar
                            </button>
                        </span>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>



<!--==========================================================MODIFICAR=============================================================-->
<div aria-hidden="true" aria-labelledby="myModalLabel" role="dialog" tabindex="-1" id="EditModal" class="modal fade">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title">Editar @ViewBag.Title</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>

                <!--<small class="font-bold">Seleccione uno de los proveedores del resultado.</small>-->
            </div>
            <div class="modal-body">
                <div class="form-group">

                    <div class="form-group">
                        <label for="txtEditCode">C&oacute;digo:</label>
                        <input type="text" class="form-control" id="txtEditCode" placeholder="C&oacute;digo" disabled>
                    </div>

                    <div class="form-group">
                        <label for="txtEditValue">Valor:</label>
                        <input type="text" class="form-control" id="txtEditValue" placeholder="Valor">
                    </div>

                    <hr />
                    <div class="input-group">
                        <span class="input-group-btn">
                            <button id="btnEditSave" class="btn btn-success" type="button" onclick="fnEdit()">
                                <span class="glyphicon glyphicon-save"></span>
                                Guardar
                            </button>
                        </span>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>




    @section Scripts {
        <script type="text/javascript">

        function fnLoadEdit(id, name)        {
            $("#txtEditCode").val(id);
            $("#txtEditValue").val(name);
        }

        function fnSave()
        {

            var par = {};
            par.Code = $("#txtCode").val();
            par.Value = $("#txtValue").val();

            $.ajax({
              url: ('@Url.Action("Save", "DocumentType")'),
              type: "POST",
              async:false,
              data: '{param:' + JSON.stringify(par) + '}',
              dataType: "json",
              contentType: "application/json; charset=utf-8",
              success: function (result) {
                  if (result.Type == "E") {
                      toastr.error(result.Message);
                      $("#CreateModal").modal('hide');
                  }
                  else {
                      toastr.success('Se guardo correctamente.');
                      $("#txtValue").prop('disabled', true);
                      $("#btnSave").prop('disabled', true);

                      fnRecargar();
                  }


              },
              error: function (result) {
                  toastr.error('Se produjo un error inesperado', 'Error');
              }
            });
        }

        function fnDelete(id)
        {

            var par = {};
            par.Code = id;


            $.ajax({
              url: ('@Url.Action("Delete", "DocumentType")'),
              type: "POST",
              async:false,
              data: '{param:' + JSON.stringify(par) + '}',
              dataType: "json",
              contentType: "application/json; charset=utf-8",
              success: function (result) {
                  if (result.Type == "E") {
                      toastr.error(result.Message);
                      fnRecargar();
                  }
                  else {
                      toastr.success('Se elimino correctamente.');
                      fnRecargar();
                  }
              },
              error: function (result) {
                  toastr.error('Se produjo un error inesperado', 'Error');
              }
            });
        }

        function fnEdit()
        {

            var par = {};
            par.Code = $("#txtEditCode").val();;
            par.Value = $("#txtEditValue").val();

            $.ajax({
              url: ('@Url.Action("Edit", "DocumentType")'),
              type: "POST",
              async:false,
              data: '{param:' + JSON.stringify(par) + '}',
              dataType: "json",
              contentType: "application/json; charset=utf-8",
              success: function (result) {
                  if (result.Type == "E") {
                      toastr.error(result.Message);
                      $("#EditModal").modal('hide');
                  }
                  else {
                      toastr.success('Se guardo correctamente.');
                      $("#txtEditValue").prop('disabled', true);
                      $("#btnEditSave").prop('disabled', true);

                      fnRecargar();
                  }


              },
              error: function (result) {
                  toastr.error('Se produjo un error inesperado', 'Error');
              }
            });
        }



         function fnRecargar()
         {
             location.reload(true);
         }


        </script>

        @Scripts.Render("~/bundles/jqueryval")
    }